/*
 *    VisNow
 *    Copyright (C) 2006-2019 University of Warsaw, ICM
 *    Copyright (C) 2020 onward visnow.org
 *    All rights reserved. 
 *
 *  This file is part of GNU Classpath.
 *
 *  GNU Classpath is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2, or (at your option)
 *  any later version.
 *
 *  GNU Classpath is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with GNU Classpath; see the file COPYING.  If not, write to the
 *  University of Warsaw, Interdisciplinary Centre for Mathematical and
 *  Computational Modelling, Pawinskiego 5a, 02-106 Warsaw, Poland.
 *
 *  Linking this library statically or dynamically with other modules is
 *  making a combined work based on this library.  Thus, the terms and
 *  conditions of the GNU General Public License cover the whole
 *  combination.
 *
 *  As a special exception, the copyright holders of this library give you
 *  permission to link this library with independent modules to produce an
 *  executable, regardless of the license terms of these independent
 *  modules, and to copy and distribute the resulting executable under
 *  terms of your choice, provided that you also meet, for each linked
 *  independent module, the terms and conditions of the license of that
 *  module.  An independent module is a module which is not derived from
 *  or based on this library.  If you modify this library, you may extend
 *  this exception to your version of the library, but you are not
 *  obligated to do so.  If you do not wish to do so, delete this
 *  exception statement from your version.
 */
 
package org.visnow.vn.geometries.gui;

import org.jogamp.java3d.LineAttributes;
import org.visnow.jscic.Field;
import org.visnow.vn.geometries.parameters.PresentationParams;

/**
 *
 ** @author Krzysztof S. Nowinski, University of Warsaw ICM
 */
public class Presentation1DPanel extends javax.swing.JPanel
{

    protected Field field;
    protected PresentationParams presentationParams = null;

    /**
     * Creates new form Presentation1DPanel
     */
    public Presentation1DPanel()
    {
        initComponents();
    }

    /**
     * This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {
        java.awt.GridBagConstraints gridBagConstraints;

        jScrollPane1 = new javax.swing.JScrollPane();
        jPanel1 = new javax.swing.JPanel();
        lineWidthSlider = new javax.swing.JSlider();
        lineStyleCombo = new javax.swing.JComboBox();
        colorPanel = new org.visnow.vn.geometries.gui.ColorMappedComponentPanel();
        filler1 = new javax.swing.Box.Filler(new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 0), new java.awt.Dimension(0, 32767));

        setLayout(new java.awt.BorderLayout());

        jScrollPane1.setHorizontalScrollBarPolicy(javax.swing.ScrollPaneConstants.HORIZONTAL_SCROLLBAR_NEVER);

        jPanel1.setLayout(new java.awt.GridBagLayout());

        lineWidthSlider.setMajorTickSpacing(50);
        lineWidthSlider.setMaximum(200);
        lineWidthSlider.setMinorTickSpacing(5);
        lineWidthSlider.setPaintTicks(true);
        lineWidthSlider.setValue(20);
        lineWidthSlider.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "line width", javax.swing.border.TitledBorder.DEFAULT_JUSTIFICATION, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("Dialog", 0, 10))); // NOI18N
        lineWidthSlider.addChangeListener(new javax.swing.event.ChangeListener() {
            public void stateChanged(javax.swing.event.ChangeEvent evt) {
                lineWidthSliderStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanel1.add(lineWidthSlider, gridBagConstraints);

        lineStyleCombo.setFont(new java.awt.Font("Dialog", 0, 12)); // NOI18N
        lineStyleCombo.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "solid", "dashed", "dotted", "dashdotted" }));
        lineStyleCombo.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                lineStyleComboItemStateChanged(evt);
            }
        });
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanel1.add(lineStyleCombo, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.fill = java.awt.GridBagConstraints.BOTH;
        gridBagConstraints.anchor = java.awt.GridBagConstraints.FIRST_LINE_START;
        gridBagConstraints.weightx = 1.0;
        jPanel1.add(colorPanel, gridBagConstraints);
        gridBagConstraints = new java.awt.GridBagConstraints();
        gridBagConstraints.gridx = 0;
        gridBagConstraints.weighty = 1.0;
        jPanel1.add(filler1, gridBagConstraints);

        jScrollPane1.setViewportView(jPanel1);

        add(jScrollPane1, java.awt.BorderLayout.CENTER);
    }// </editor-fold>//GEN-END:initComponents

    private void lineWidthSliderStateChanged(javax.swing.event.ChangeEvent evt)//GEN-FIRST:event_lineWidthSliderStateChanged
    {//GEN-HEADEREND:event_lineWidthSliderStateChanged
        if (presentationParams != null)
            presentationParams.getRenderingParams().setLineThickness(lineWidthSlider.getValue() / 20.f);
    }//GEN-LAST:event_lineWidthSliderStateChanged

    private void lineStyleComboItemStateChanged(java.awt.event.ItemEvent evt)//GEN-FIRST:event_lineStyleComboItemStateChanged
    {//GEN-HEADEREND:event_lineStyleComboItemStateChanged
        if (presentationParams != null)
            switch (lineStyleCombo.getSelectedIndex()) {
            case 0:
                presentationParams.getRenderingParams().setLineStyle(LineAttributes.PATTERN_SOLID);
                break;
            case 1:
                presentationParams.getRenderingParams().setLineStyle(LineAttributes.PATTERN_DASH);
                break;
            case 2:
                presentationParams.getRenderingParams().setLineStyle(LineAttributes.PATTERN_DOT);
                break;
            case 3:
                presentationParams.getRenderingParams().setLineStyle(LineAttributes.PATTERN_DASH_DOT);
                break;

            }
    }//GEN-LAST:event_lineStyleComboItemStateChanged

    public void setInFieldDisplayData(Field field, PresentationParams fieldDisplayParams)
    {
        if (field != null && (this.field == null || !field.isFullyCompatibleWith(this.field))) {
            presentationParams = fieldDisplayParams.getChild(0);
            colorPanel.setParams(presentationParams.getDataMappingParams());
            colorPanel.setData(field.getSchema());
        }
        this.field = field;
    }

    public void updateDataValues(Field field)
    {
        colorPanel.setData(field.getSchema());
    }

    public ColorMappedComponentPanel getColorPanel()
    {
        return colorPanel;
    }

    public boolean isAdjusting()
    {
        return lineWidthSlider.getValueIsAdjusting() || colorPanel.isAdjusting();
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    protected org.visnow.vn.geometries.gui.ColorMappedComponentPanel colorPanel;
    protected javax.swing.Box.Filler filler1;
    protected javax.swing.JPanel jPanel1;
    protected javax.swing.JScrollPane jScrollPane1;
    protected javax.swing.JComboBox lineStyleCombo;
    protected javax.swing.JSlider lineWidthSlider;

    // End of variables declaration//GEN-END:variables
    public org.visnow.vn.geometries.gui.ColorMappedComponentPanel getColorPanle()
    {
        return colorPanel;
    }
}
